"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const listService_1 = require("../services/resultCenter/listService");
const detailsService_1 = require("../services/resultCenter/detailsService");
class ResultCenterController {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listResultCenterService = new listService_1.ListResultCenterService();
            const execute = yield listResultCenterService.execute(request.user_cod, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listDetails(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { cod, planoContas, dataIni, dataFim } = request.params;
            console.log('====================================');
            console.log(cod, planoContas, dataIni, dataFim);
            console.log('====================================');
            const detailsResultCenterService = new detailsService_1.DetailsResultCenterService();
            const execute = yield detailsResultCenterService.execute(cod, planoContas, dataIni, dataFim, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
}
exports.default = ResultCenterController;
