"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.routerPurchaseOrder = void 0;
const express_1 = __importDefault(require("express"));
const purchaseOrderController_1 = require("../../controllers/purchaseOrderController");
const isAuthenticatedAcess_1 = __importDefault(require("../../middlewares/isAuthenticatedAcess"));
exports.routerPurchaseOrder = express_1.default.Router();
const purchaseOrderController = new purchaseOrderController_1.PurchaseOrderController();
exports.routerPurchaseOrder.get('/', isAuthenticatedAcess_1.default, purchaseOrderController.list);
exports.routerPurchaseOrder.patch('/', isAuthenticatedAcess_1.default, purchaseOrderController.approvalOrderPurchase);
exports.routerPurchaseOrder.get('/numero/:numeroSoco', isAuthenticatedAcess_1.default, purchaseOrderController.listFilerNumber);
exports.routerPurchaseOrder.get('/almoxarifado/:almoDesc', isAuthenticatedAcess_1.default, purchaseOrderController.listFilerWarehouse);
exports.routerPurchaseOrder.get('/setorCompras/:secoDesc', isAuthenticatedAcess_1.default, purchaseOrderController.listFilerPurchasingSector);
exports.routerPurchaseOrder.get('/cr/:crCod', isAuthenticatedAcess_1.default, purchaseOrderController.listFilerCr);
exports.routerPurchaseOrder.get('/data/:data', isAuthenticatedAcess_1.default, purchaseOrderController.listFilerDate);
exports.routerPurchaseOrder.post('/create', isAuthenticatedAcess_1.default, purchaseOrderController.addPurchase);
