"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.routerRequest = void 0;
const express_1 = __importDefault(require("express"));
const requestController_1 = __importDefault(require("../../controllers/requestController"));
const isAuthenticatedAcess_1 = __importDefault(require("../../middlewares/isAuthenticatedAcess"));
exports.routerRequest = express_1.default.Router();
const request = new requestController_1.default();
exports.routerRequest.get('/', isAuthenticatedAcess_1.default, request.list);
exports.routerRequest.get('/numero/:numero', isAuthenticatedAcess_1.default, request.listNumber);
exports.routerRequest.get('/forn/:forn', isAuthenticatedAcess_1.default, request.listForn);
exports.routerRequest.get('/func/:func', isAuthenticatedAcess_1.default, request.listFunc);
exports.routerRequest.get('/detalhe/:pediCod', isAuthenticatedAcess_1.default, request.listItems);
exports.routerRequest.patch('/', isAuthenticatedAcess_1.default, request.approvalRequest);
exports.routerRequest.patch('/largeScale', isAuthenticatedAcess_1.default, request.approvalLargeScale);
