"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListCrService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const cr_1 = require("../../queries/cr");
const verifyUser_1 = require("../../utils/verifyUser");
class ListCrService {
    execute(cod, almoCod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { message, error, userTipo } = yield (0, verifyUser_1.verifyUsercodWithOutSignUp)(cod, database);
                if (error) {
                    return ({
                        error: true,
                        message,
                        status: 403
                    });
                }
                const sqlParametro = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT 
          PAGE_COMPRAS_CR_ALMOXARIFADO
        FROM
          PARAMETROS_GERAIS
    `);
                if (userTipo === 'E') {
                    if (sqlParametro[0].PAGE_COMPRAS_CR_ALMOXARIFADO === 'S') {
                        const selectCrForAlmoSql = (0, cr_1.selectCrForAlmo)(almoCod, database);
                        const selectCrForAlmoQuery = yield usuarioRepositories_1.UsuarioRepository.query(selectCrForAlmoSql);
                        return ({
                            error: false,
                            message: selectCrForAlmoQuery,
                            status: 200
                        });
                    }
                    const selectAllCrFiliAlmoSql = (0, cr_1.selectAllCrFiliAlmo)(almoCod, database);
                    const selectAllCrFiliAlmoQuery = yield usuarioRepositories_1.UsuarioRepository.query(selectAllCrFiliAlmoSql);
                    return ({
                        error: false,
                        message: selectAllCrFiliAlmoQuery,
                        status: 200
                    });
                }
                if (sqlParametro[0].PAGE_COMPRAS_CR_ALMOXARIFADO === 'S') {
                    const selectCrForAlmoUsuaSql = (0, cr_1.selectCrForAlmoUsua)(almoCod, cod, database);
                    const selectCrForAlmoUsuaQuery = yield usuarioRepositories_1.UsuarioRepository.query(selectCrForAlmoUsuaSql);
                    return ({
                        error: false,
                        message: selectCrForAlmoUsuaQuery,
                        status: 200
                    });
                }
                const selectAllCrFiliAlmoUsuaSql = (0, cr_1.selectAllCrFiliAlmoUsua)(almoCod, cod, database);
                const selectAllCrFiliAlmoUsuaQuery = yield usuarioRepositories_1.UsuarioRepository.query(selectAllCrFiliAlmoUsuaSql);
                return {
                    error: false,
                    message: selectAllCrFiliAlmoUsuaQuery,
                    status: 200
                };
            }
            catch (e) {
                return ({
                    error: true,
                    message: 'Internal Server Error',
                    status: 500
                });
            }
        });
    }
}
exports.ListCrService = ListCrService;
