"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListPurchaseOrderService = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const purchaseOrder_1 = require("../../queries/purchaseOrder");
class ListPurchaseOrderService {
    execute(cod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const query2 = (0, purchaseOrder_1.selectSoliComp2)(cod, database);
                const query1 = (0, purchaseOrder_1.selectSoliComp1)(cod, database);
                const listPurchaseOrder1 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(query1);
                const listPurchaseOrder2 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(query2);
                const orderArray = [];
                if (listPurchaseOrder1.length > 0) {
                    listPurchaseOrder1.map((pos) => orderArray.push(pos));
                }
                if (listPurchaseOrder2.length > 0) {
                    listPurchaseOrder2.map((pos) => orderArray.push(pos));
                }
                return {
                    error: false,
                    message: orderArray,
                    status: 200
                };
            }
            catch (e) {
                return {
                    error: true,
                    message: `Internal Server Error: ${e}`,
                    status: 500
                };
            }
        });
    }
}
exports.ListPurchaseOrderService = ListPurchaseOrderService;
