"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApprovalServiceContract = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const serviceContract_1 = require("../../queries/serviceContract");
const verifyUser_1 = require("../../utils/verifyUser");
class ApprovalServiceContract {
    execute(sigla, ass, codCocs, password, valTotal, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { error, message, status, USUA_VALOR_APROVA_CONT_SERV } = yield (0, verifyUser_1.verifyUserApproval)(sigla, password, database);
                if (error) {
                    return ({
                        message,
                        erro: error,
                        status
                    });
                }
                if (Number(USUA_VALOR_APROVA_CONT_SERV) < parseFloat(valTotal)) {
                    return ({
                        message: `Contrato ${codCocs} não pode ser aprovado valor acima do de aprovação do úsuario`,
                        erro: true,
                        status: 403
                    });
                }
                const selectPageNumAprova = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(`
      USE [${database}]
      SELECT 
        PAG2_NUM_APROVACOES_CONTR,
        PAG2_TODAS_APROVACOES_CONTR
      FROM 
        PARAMETROS_GERAIS_2
    `);
                const sql = (0, serviceContract_1.countNumAprov)(codCocs, database);
                const selectQtdAprova = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
                let statusSQL = '';
                if (selectPageNumAprova[0].PAG2_TODAS_APROVACOES_CONTR === 'S') {
                    if (selectPageNumAprova[0].PAG2_NUM_APROVACOES_CONTR === 1) {
                        statusSQL = "COCS_STATUS = 'AP',";
                    }
                    else if (selectPageNumAprova[0].PAG2_NUM_APROVACOES_CONTR === 2 && selectQtdAprova[0].NUM === 1) {
                        statusSQL = "COCS_STATUS = 'AP',";
                    }
                    else if (selectPageNumAprova[0].PAG2_NUM_APROVACOES_CONTR === 3 && selectQtdAprova[0].NUM === 2) {
                        statusSQL = "COCS_STATUS = 'AP',";
                    }
                    else if (selectPageNumAprova[0].PAG2_NUM_APROVACOES_CONTR === 4 && selectQtdAprova[0].NUM === 3) {
                        statusSQL = "COCS_STATUS = 'AP',";
                    }
                }
                else {
                    statusSQL = "COCS_STATUS = 'AP',";
                }
                const sql2 = (0, serviceContract_1.attContratoCompraServico)(codCocs, ass, statusSQL, database);
                yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql2);
                return {
                    status: 200,
                    message: `Contrato ${codCocs} aprovado com sucesso`,
                    erro: false
                };
            }
            catch (e) {
                return ({
                    message: 'Internal server error' + e,
                    erro: true,
                    status: 500
                });
            }
        });
    }
}
exports.ApprovalServiceContract = ApprovalServiceContract;
