"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListSectorService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const setorCompra_1 = require("../../queries/setorCompra");
class ListSectorService {
    execute(cod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const sqlParametro = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT 
          PAGE_REL_USUARIO_SETOR_COMPRAS
        FROM
          PARAMETROS_GERAIS
    `);
                if (sqlParametro[0].PAGE_REL_USUARIO_SETOR_COMPRAS === 'S') {
                    const setorComprasUsuaSql = (0, setorCompra_1.selectSetorCompraUsua)(cod, database);
                    const setorComprasUsuaQuery = yield usuarioRepositories_1.UsuarioRepository.query(setorComprasUsuaSql);
                    return {
                        error: false,
                        message: setorComprasUsuaQuery,
                        status: 200
                    };
                }
                const setorComprasUsuaSql = (0, setorCompra_1.selectAllSetorCompras)(database);
                const setorComprasUsuaQuery = yield usuarioRepositories_1.UsuarioRepository.query(setorComprasUsuaSql);
                return {
                    error: false,
                    message: setorComprasUsuaQuery,
                    status: 200
                };
            }
            catch (e) {
                return {
                    error: true,
                    message: 'Internal server error',
                    status: 500
                };
            }
        });
    }
}
exports.ListSectorService = ListSectorService;
