"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppDataSource = void 0;
/* eslint-disable n/no-path-concat */
const typeorm_1 = require("typeorm");
require("reflect-metadata");
const dotenv_1 = require("dotenv");
(0, dotenv_1.config)();
exports.AppDataSource = new typeorm_1.DataSource({
    type: 'mssql',
    host: process.env.SERVER,
    username: process.env.USERDB,
    password: process.env.PASSWORDDB,
    database: process.env.DATABASEDB,
    synchronize: true,
    requestTimeout: 60000,
    logging: false,
    extra: {
        encrypt: false,
        trustServerCertificate: true
    },
    entities: [`${__dirname}/entities/*.{ts,js}`],
    migrations: [`${__dirname}/migrations/*.{ts,js}`]
});
