"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControlLicense = void 0;
const userControlMobile_1 = require("../queries/userControlMobile");
const usuarioRepositories_1 = require("../typeorm/repository/usuarioRepositories");
const ControlLicense = (sigla, cnpj) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const logado = yield usuarioRepositories_1.UsuarioRepository.query(`
      USE [MOBILE_CCONNECTION]
      SELECT 
        COUNT(USCM_USUA_SIGLA) AS LOGGED
      FROM
        USER_CONTROL_MOBILE
      INNER JOIN
        DATA_CONNECTION
      ON
        DACO_COD = USCM_DACO_COD
      WHERE
        USCM_USUA_SIGLA = '${sigla}'
      AND
        USCM_ATIVO = 'S'
      AND
        DACO_CNPJ = '${cnpj}'        
    `);
        if (logado[0].LOGGED === 0) {
            const usuarios = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [MOBILE_CCONNECTION]
        SELECT
          DISTINCT(USCM_USUA_SIGLA)
        FROM
          USER_CONTROL_MOBILE
        INNER JOIN
          DATA_CONNECTION
        ON
          DACO_COD = USCM_DACO_COD          
        WHERE
          USCM_USUA_SIGLA != '${sigla}'
        AND
          DACO_CNPJ = '${cnpj}'                
      `);
            if (usuarios.length > 0) {
                usuarios.forEach((element) => __awaiter(void 0, void 0, void 0, function* () {
                    const sqlQueryTransformN = (0, userControlMobile_1.queryTransformN)(cnpj, element.USCM_USUA_SIGLA);
                    yield usuarioRepositories_1.UsuarioRepository.query(sqlQueryTransformN);
                }));
            }
            const licenseFree = yield usuarioRepositories_1.UsuarioRepository.query((0, userControlMobile_1.licenseQuantity)(cnpj));
            if (licenseFree[0].FREE_LICENSE > 0) {
                return {
                    error: false,
                    message: '',
                    status: 200
                };
            }
            return {
                error: true,
                message: 'Máximo de licenças ocupada',
                status: 403
            };
        }
        return {
            error: false,
            message: '',
            status: 200
        };
    }
    catch (e) {
        return {
            error: true,
            message: 'Internal server error' + e,
            status: 500
        };
    }
});
exports.ControlLicense = ControlLicense;
