"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiredStringPropertyMissingMunLength = void 0;
const RequiredStringPropertyMissingMunLength = () => {
    let skipSchemaProperties;
    let requiredPropertiesSet;
    return {
        Schema: {
            enter(schema) {
                if (!(schema === null || schema === void 0 ? void 0 : schema.required)) {
                    skipSchemaProperties = true;
                    return;
                }
                requiredPropertiesSet = new Set(schema.required);
                skipSchemaProperties = false;
            },
            SchemaProperties: {
                skip() {
                    return skipSchemaProperties;
                },
                Schema: {
                    enter(schema, { key, location, report }) {
                        if (requiredPropertiesSet.has(key) && schema.type === 'string') {
                            if (!(schema === null || schema === void 0 ? void 0 : schema.minLength)) {
                                report({
                                    message: 'Property minLength is required.',
                                    location: location.key(),
                                });
                            }
                        }
                    },
                },
            },
        },
    };
};
exports.RequiredStringPropertyMissingMunLength = RequiredStringPropertyMissingMunLength;
