"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const GetDailyMovimentServices_1 = require("../services/dayleMoviment/GetDailyMovimentServices");
const GetDailyMovimentComboAplicacaoServices_1 = require("../services/dayleMoviment/GetDailyMovimentComboAplicacaoServices");
const FilterAplicacaoService_1 = require("../services/dayleMoviment/FilterAplicacaoService");
const FilterDataAndAplMovimentService_1 = require("../services/dayleMoviment/FilterDataAndAplMovimentService");
const DetailsMoivmentService_1 = require("../services/dayleMoviment/DetailsMoivmentService");
class DailyMovimentController {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const getDailyMovimentServices = new GetDailyMovimentServices_1.GetDailyMovimentServices();
            const execute = yield getDailyMovimentServices.execute(request.user_cod, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listCmb(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const getDailyMovimentComboAplicacaoServices = new GetDailyMovimentComboAplicacaoServices_1.GetDailyMovimentComboAplicacaoServices();
            const execute = yield getDailyMovimentComboAplicacaoServices.execute(request.user_cod, request.database);
            return response.status(execute.status).json(execute.messsage);
        });
    }
    FilterAplicacaoNome(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { aplicacao } = request.params;
            if (!aplicacao) {
                return response.status(400).json({ message: 'Data is missing' });
            }
            const filterAplicacao = new FilterAplicacaoService_1.FilterAplicacao();
            const execute = yield filterAplicacao.execute(request.user_cod, aplicacao, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    FilterAplicacaoDataAndApl(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { aplicacao, dataIni, dataFim } = request.body;
            if (!dataIni || !dataFim) {
                return response.status(400).json({ message: 'Data is missing' });
            }
            const filterDataAndAplMovimentService = new FilterDataAndAplMovimentService_1.FilterDataAndAplMovimentService();
            const execute = yield filterDataAndAplMovimentService.execute(request.user_cod, dataIni, dataFim, aplicacao, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    DetailsAplicacaoDataAndApl(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { aplicacao, date } = request.query;
            if (!date) {
                return response.status(400).json({ message: 'Data is missing' });
            }
            const detailsMoivmentService = new DetailsMoivmentService_1.DetailsMoivmentService();
            if (!aplicacao) {
                const execute = yield detailsMoivmentService.execute(request.user_cod, date.toString(), '', request.database);
                return response.status(execute.status).json(execute.message);
            }
            const execute = yield detailsMoivmentService.execute(request.user_cod, date.toString(), aplicacao.toString(), request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
}
exports.default = DailyMovimentController;
