"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PurchaseOrderController = void 0;
const listPurchaseOrder_1 = require("../services/purchase_order/listPurchaseOrder");
const approvalPurchaseOrder_1 = require("../services/purchase_order/approvalPurchaseOrder");
const listPurchaseOrderNumber_1 = require("../services/purchase_order/listPurchaseOrderNumber");
const listPurchaseOrderAlmoxa_1 = require("../services/purchase_order/listPurchaseOrderAlmoxa");
const listPurchaseOrderPurchasingSector_1 = require("../services/purchase_order/listPurchaseOrderPurchasingSector");
const listPurchaseOrderCR_1 = require("../services/purchase_order/listPurchaseOrderCR");
const listPurchaseOrderDate_1 = require("../services/purchase_order/listPurchaseOrderDate");
const createPurchase_1 = require("../services/purchase_order/createPurchase");
class PurchaseOrderController {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listPurchaseOrderService = new listPurchaseOrder_1.ListPurchaseOrderService();
            const listPurchaseOrderServiceExec = yield listPurchaseOrderService.execute(request.user_cod, request.database);
            response.status(listPurchaseOrderServiceExec.status).json(listPurchaseOrderServiceExec.message);
        });
    }
    approvalOrderPurchase(request, response) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const approvalPurchaseOrderService = new approvalPurchaseOrder_1.ApprovalPurchaseOrderService();
            const { USUA_SENHA_APP, arraySolicitacaoCompra } = request.body;
            let status = 200;
            const message = [];
            try {
                for (var _d = true, arraySolicitacaoCompra_1 = __asyncValues(arraySolicitacaoCompra), arraySolicitacaoCompra_1_1; arraySolicitacaoCompra_1_1 = yield arraySolicitacaoCompra_1.next(), _a = arraySolicitacaoCompra_1_1.done, !_a;) {
                    _c = arraySolicitacaoCompra_1_1.value;
                    _d = false;
                    try {
                        const item = _c;
                        console.log('====================================');
                        console.log(item);
                        console.log('====================================');
                        const execute = yield approvalPurchaseOrderService.execute(request.user_sigla, USUA_SENHA_APP, item.pos, item.socoCod, item.valTotal, request.database);
                        if (execute.error) {
                            status = execute.status;
                        }
                        message.push(execute.message);
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = arraySolicitacaoCompra_1.return)) yield _b.call(arraySolicitacaoCompra_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return response.status(status).json({
                message,
                status
            });
        });
    }
    listFilerNumber(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { numeroSoco } = request.params;
            const listPurchaseOrderNumberService = new listPurchaseOrderNumber_1.ListPurchaseOrderNumberService();
            const listPurchaseOrderNumberServiceExec = yield listPurchaseOrderNumberService.execute(request.user_cod, numeroSoco, request.database);
            response.status(listPurchaseOrderNumberServiceExec.status).json(listPurchaseOrderNumberServiceExec.message);
        });
    }
    listFilerWarehouse(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { almoDesc } = request.params;
            const listPurchaseOrderWarehouseService = new listPurchaseOrderAlmoxa_1.ListPurchaseOrderWarehouseService();
            const listPurchaseOrderWarehouseServiceExec = yield listPurchaseOrderWarehouseService.execute(request.user_cod, almoDesc, request.database);
            response.status(listPurchaseOrderWarehouseServiceExec.status).json(listPurchaseOrderWarehouseServiceExec.message);
        });
    }
    listFilerPurchasingSector(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { secoDesc } = request.params;
            const listPurchaseOrderPurchasingSector = new listPurchaseOrderPurchasingSector_1.ListPurchaseOrderPurchasingSector();
            const listPurchaseOrderPurchasingSectorExec = yield listPurchaseOrderPurchasingSector.execute(request.user_cod, secoDesc, request.database);
            response.status(listPurchaseOrderPurchasingSectorExec.status).json(listPurchaseOrderPurchasingSectorExec.message);
        });
    }
    listFilerCr(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { crCod } = request.params;
            const listPurchaseOrderCrService = new listPurchaseOrderCR_1.ListPurchaseOrderCrService();
            const listPurchaseOrderCrServiceExec = yield listPurchaseOrderCrService.execute(request.user_cod, crCod, request.database);
            response.status(listPurchaseOrderCrServiceExec.status).json(listPurchaseOrderCrServiceExec.message);
        });
    }
    listFilerDate(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { data } = request.params;
            const listPurchaseOrderDateService = new listPurchaseOrderDate_1.ListPurchaseOrderDateService();
            const listPurchaseOrderDateServiceExec = yield listPurchaseOrderDateService.execute(request.user_cod, data, request.database);
            response.status(listPurchaseOrderDateServiceExec.status).json(listPurchaseOrderDateServiceExec.message);
        });
    }
    addPurchase(request, response) {
        var _a, e_2, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const { secoCod, itpcCod, cereCod, almoCod, dtNece, arrayMaterial, pessCodSoli, ass1, ass2, itpcRateioCod, debitoDireto } = request.body;
            const message = [];
            console.log('array====================================');
            console.log(arrayMaterial);
            console.log('====================================');
            let status = 200;
            let error = false;
            const create = new createPurchase_1.CreatePurchase();
            try {
                for (var _d = true, arrayMaterial_1 = __asyncValues(arrayMaterial), arrayMaterial_1_1; arrayMaterial_1_1 = yield arrayMaterial_1.next(), _a = arrayMaterial_1_1.done, !_a;) {
                    _c = arrayMaterial_1_1.value;
                    _d = false;
                    try {
                        const element = _c;
                        const cod = request.user_cod;
                        const unmaCod = element.mateUnidMatCod;
                        const qtd = element.mateQuantidade;
                        const mateCod = element.mateCod;
                        const servCod = element.servCod;
                        const createExec = yield create.execute({
                            secoCod,
                            servCod,
                            itpcRateioCod,
                            cereCod,
                            unmaCod,
                            almoCod,
                            dtNece,
                            qtd,
                            mateCod,
                            pessCodSoli,
                            ass1,
                            ass2,
                            cod,
                            database: request.database,
                            itpcCod,
                            debitoDireto
                        });
                        if (createExec.error === true) {
                            status = createExec.status;
                            error = true;
                        }
                        message.push(createExec.message);
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = arrayMaterial_1.return)) yield _b.call(arrayMaterial_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            response.status(status).json({
                message,
                status,
                error
            });
        });
    }
}
exports.PurchaseOrderController = PurchaseOrderController;
