"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const ListPedidoService_1 = require("../services/request/ListPedidoService");
const approvalRequest_1 = require("../services/request/approvalRequest");
const getDetailsRequestServices_1 = require("../services/request/getDetailsRequestServices");
const request_1 = require("../queries/request");
const pedidoEstoqueRepositories_1 = require("../typeorm/repository/pedidoEstoqueRepositories");
const validCereForn_1 = require("../services/request/validCereForn");
class DailyMovimentController {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listPedidoService = new ListPedidoService_1.ListPedidoService();
            const execute = yield listPedidoService.execute(request.user_cod, '', request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listNumber(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { numero } = request.params;
            const queryString = `
    AND
      PEDI_NUMERO = '${numero}'
    `;
            const listPedidoNumberService = new ListPedidoService_1.ListPedidoService();
            const execute = yield listPedidoNumberService.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listForn(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { forn } = request.params;
            const queryString = `
    AND
      FORN_NOME LIKE '%${forn}%'
    `;
            const listPedidoFornService = new ListPedidoService_1.ListPedidoService();
            const execute = yield listPedidoFornService.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listFunc(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { func } = request.params;
            const queryString = `
    AND
      PESS_NOME LIKE '%${func}%'
    `;
            const listPedidoFuncService = new ListPedidoService_1.ListPedidoService();
            const execute = yield listPedidoFuncService.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    approvalRequest(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { USUA_SENHA_APP, posUsuaCod, pediCod, fornCod, valTotal, pediNumero } = request.body;
            const approvalRequestService = new approvalRequest_1.ApprovalRequestService();
            const sql = (0, request_1.selectCerePeitPedi)(pediCod);
            const sqlExec = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
            for (let i = 0; i < sqlExec.length; i++) {
                const valid = yield (0, validCereForn_1.validCereFornPedi)(request.user_cod, sqlExec[i].CERE_COD, valTotal, fornCod, pediCod, request.database);
                if (valid.error === true) {
                    return response.status(valid.status).json(valid);
                }
            }
            const approvalRequestExec = yield approvalRequestService.execute(request.user_sigla, USUA_SENHA_APP, posUsuaCod, pediCod, pediNumero, request.database);
            return response.status(approvalRequestExec.status).json(approvalRequestExec);
        });
    }
    approvalLargeScale(request, response) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const { USUA_SENHA_APP, arrayPedido } = request.body;
            const pedidosTxt = [];
            let status = 200;
            let error = false;
            try {
                for (var _d = true, arrayPedido_1 = __asyncValues(arrayPedido), arrayPedido_1_1; arrayPedido_1_1 = yield arrayPedido_1.next(), _a = arrayPedido_1_1.done, !_a;) {
                    _c = arrayPedido_1_1.value;
                    _d = false;
                    try {
                        const item = _c;
                        const sql = (0, request_1.selectCerePeitPedi)(item.pediCod);
                        const sqlExec = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
                        for (let i = 0; i < sqlExec.length; i++) {
                            const valid = yield (0, validCereForn_1.validCereFornPedi)(request.user_cod, sqlExec[i].CERE_COD, item.valTotal, item.fornCod, item.pediCod, request.database);
                            if (valid.error === true) {
                                pedidosTxt.push(valid.message);
                                status = 400;
                                error = true;
                                break;
                            }
                            if (i === sqlExec.length || valid.error === false) {
                                const approvalRequestService = new approvalRequest_1.ApprovalRequestService();
                                const approvalRequestExec = yield approvalRequestService.execute(request.user_sigla, USUA_SENHA_APP, item.ASS, item.pediCod, item.pediNumero, request.database);
                                pedidosTxt.push(approvalRequestExec.message);
                                status = approvalRequestExec.status;
                                error = approvalRequestExec.error;
                            }
                        }
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = arrayPedido_1.return)) yield _b.call(arrayPedido_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            console.log('====================================');
            console.log(pedidosTxt);
            console.log('====================================');
            return response.status(status).json({
                message: pedidosTxt,
                error,
                status
            });
        });
    }
    listItems(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { pediCod } = request.params;
            const getDetailsRequestServices = new getDetailsRequestServices_1.GetDetailsRequestServices();
            const execute = yield getDetailsRequestServices.execute(pediCod, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
}
exports.default = DailyMovimentController;
