"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceContractBulletinController = void 0;
const listServiceContractBulletin_1 = require("../services/serviceContractBulletin/listServiceContractBulletin");
const listDetailsService_1 = require("../services/serviceContractBulletin/listDetailsService");
const approvalService_1 = require("../services/serviceContractBulletin/approvalService");
const listServiceBulletinApprovaded_1 = require("../services/serviceContractBulletin/listServiceBulletinApprovaded");
class ServiceContractBulletinController {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceContractBulletinService = new listServiceContractBulletin_1.ServiceContractBulletinService();
            const result = yield serviceContractBulletinService.execute(request.user_cod, request.database, '');
            return response.status(result.status).json(result.message);
        });
    }
    listCocs(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceContractBulletinService = new listServiceContractBulletin_1.ServiceContractBulletinService();
            const { codCocs } = request.params;
            const queryString = `
      AND
        BOCS_COCS_COD = ${codCocs}
    `;
            const result = yield serviceContractBulletinService.execute(request.user_cod, request.database, queryString);
            return response.status(result.status).json(result.message);
        });
    }
    listNum(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceContractBulletinService = new listServiceContractBulletin_1.ServiceContractBulletinService();
            const { numBocs } = request.params;
            const queryString = `
      AND
        BOCS_NUMERO = ${numBocs}
    `;
            const result = yield serviceContractBulletinService.execute(request.user_cod, request.database, queryString);
            return response.status(result.status).json(result.message);
        });
    }
    listFornCod(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceContractBulletinService = new listServiceContractBulletin_1.ServiceContractBulletinService();
            const { fornCod } = request.params;
            console.log('====================================');
            console.log(fornCod);
            console.log('====================================');
            const queryString = `
      AND
        COCS_FORN_COD = ${fornCod}
    `;
            const result = yield serviceContractBulletinService.execute(request.user_cod, request.database, queryString);
            return response.status(result.status).json(result.message);
        });
    }
    listCereCod(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceContractBulletinService = new listServiceContractBulletin_1.ServiceContractBulletinService();
            const { cereCod } = request.params;
            console.log('====================================');
            console.log(cereCod);
            console.log('====================================');
            const queryString = `
      AND
        COCS_CERE_COD = ${cereCod}
    `;
            const result = yield serviceContractBulletinService.execute(request.user_cod, request.database, queryString);
            return response.status(result.status).json(result.message);
        });
    }
    listAprrovaded(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceContractBulletinServiceApprovaded = new listServiceBulletinApprovaded_1.ServiceContractBulletinServiceApprovaded();
            const result = yield serviceContractBulletinServiceApprovaded.execute(request.user_cod, request.database);
            return response.status(result.status).json(result.message);
        });
    }
    listDetails(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listDetailsBulletin = new listDetailsService_1.ListDetailsBulletin();
            const { cod } = request.params;
            const result = yield listDetailsBulletin.execute(cod, request.database);
            return response.status(result.status).json(result.message);
        });
    }
    approval(request, response) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const approvalBulletinService = new approvalService_1.ApprovalBulletinService();
            const { password, arrayBoletimC } = request.body;
            const msgCocs = [];
            let status = 200;
            let error = false;
            try {
                for (var _d = true, arrayBoletimC_1 = __asyncValues(arrayBoletimC), arrayBoletimC_1_1; arrayBoletimC_1_1 = yield arrayBoletimC_1.next(), _a = arrayBoletimC_1_1.done, !_a;) {
                    _c = arrayBoletimC_1_1.value;
                    _d = false;
                    try {
                        const item = _c;
                        const execute = yield approvalBulletinService.execute(request.user_cod, item.cod, item.posAss, password, item.cereCod, item.valor, item.fornCod, request.database, request.user_sigla);
                        if (execute.erro === true) {
                            status = 400;
                            error = true;
                        }
                        msgCocs.push(execute.message);
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = arrayBoletimC_1.return)) yield _b.call(arrayBoletimC_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return response.status(status).json({
                message: msgCocs,
                status,
                error
            });
        });
    }
}
exports.ServiceContractBulletinController = ServiceContractBulletinController;
