"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.routerDailyMoviment = void 0;
const express_1 = __importDefault(require("express"));
const dailyMovimentController_1 = __importDefault(require("../../controllers/dailyMovimentController"));
const isAuthenticatedAcess_1 = __importDefault(require("../../middlewares/isAuthenticatedAcess"));
exports.routerDailyMoviment = express_1.default.Router();
const DailyMoviment = new dailyMovimentController_1.default();
exports.routerDailyMoviment.get('/', isAuthenticatedAcess_1.default, DailyMoviment.list);
exports.routerDailyMoviment.get('/cmbAplicacao', isAuthenticatedAcess_1.default, DailyMoviment.listCmb);
exports.routerDailyMoviment.get('/filter/aplicacao/:aplicacao', isAuthenticatedAcess_1.default, DailyMoviment.FilterAplicacaoNome);
exports.routerDailyMoviment.get('/filter/aplicacaoData', isAuthenticatedAcess_1.default, DailyMoviment.FilterAplicacaoDataAndApl);
exports.routerDailyMoviment.get('/details/aplicacaoData', isAuthenticatedAcess_1.default, DailyMoviment.DetailsAplicacaoDataAndApl);
