"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.routerV1 = void 0;
const express_1 = __importDefault(require("express"));
const user_routes_1 = require("./user.routes");
const swagger_ui_express_1 = __importDefault(require("swagger-ui-express"));
const swagger_json_1 = __importDefault(require("../../swagger/swagger.json"));
const dailyMoviment_routes_1 = require("./dailyMoviment.routes");
const request_routes_1 = require("./request.routes");
const company_routes_1 = __importDefault(require("./company.routes"));
const purchaseOrder_routes_1 = require("./purchaseOrder.routes");
const serviceContract_routes_1 = require("./serviceContract.routes");
const bulletinService_routes_1 = require("./bulletinService.routes");
const schedule_routes_1 = require("./schedule.routes");
const additiveContract_routes_1 = require("./additiveContract.routes");
const additiveContractTerm_routes_1 = require("./additiveContractTerm.routes");
const resultCenter_routes_1 = require("./resultCenter.routes");
const dataConnection_routes_1 = require("./dataConnection.routes");
const update_routes_1 = require("./update.routes");
const sectorPurchase_routes_1 = require("./sectorPurchase.routes");
const material_routes_1 = require("./material.routes");
const warehouse_routes_1 = require("./warehouse.routes");
const service_routes_1 = require("./service.routes");
const cr_routes_1 = require("./cr.routes");
const unidMat_routes_1 = require("./unidMat.routes");
const guys_routes_1 = require("./guys.routes");
const itemPcg_routes_1 = require("./itemPcg.routes");
const page_routes_1 = require("./page.routes");
const notification_routes_1 = require("./notification.routes");
const purchaseWorksheet_routes_1 = __importDefault(require("./purchaseWorksheet.routes"));
const pay_routes_1 = require("./pay.routes");
const branch_routes_1 = require("./branch.routes");
const local_routes_1 = require("./local.routes");
const supplier_routes_1 = require("./supplier.routes");
exports.routerV1 = express_1.default.Router();
exports.routerV1.use('/dataConnection', dataConnection_routes_1.routerDataConnection);
exports.routerV1.use('/usuario', user_routes_1.routerUser);
exports.routerV1.use('/dailyMoviment', dailyMoviment_routes_1.routerDailyMoviment);
exports.routerV1.use('/doc', swagger_ui_express_1.default.serve, swagger_ui_express_1.default.setup(swagger_json_1.default));
exports.routerV1.use('/pedido', request_routes_1.routerRequest);
exports.routerV1.use('/empresa', company_routes_1.default);
exports.routerV1.use('/solicitacaoCompra', purchaseOrder_routes_1.routerPurchaseOrder);
exports.routerV1.use('/contratoServico', serviceContract_routes_1.routerServiceContract);
exports.routerV1.use('/boletimServico', bulletinService_routes_1.routerBulletin);
exports.routerV1.use('/agenda', schedule_routes_1.routerSchedule);
exports.routerV1.use('/contratoAditivo', additiveContract_routes_1.routerContractAdditive);
exports.routerV1.use('/contratoAditivoPR', additiveContractTerm_routes_1.routerContractAdditiveTerm);
exports.routerV1.use('/atualizacao', update_routes_1.routerUpdate);
exports.routerV1.use('/cr', resultCenter_routes_1.routerResultCenter);
exports.routerV1.use('/setorCompra', sectorPurchase_routes_1.routerSector);
exports.routerV1.use('/material', material_routes_1.routerMaterial);
exports.routerV1.use('/almoxarifado', warehouse_routes_1.routerWarehouse);
exports.routerV1.use('/servicos', service_routes_1.routerServices);
exports.routerV1.use('/cr', cr_routes_1.routerCr);
exports.routerV1.use('/unidMat', unidMat_routes_1.routerUnidMat);
exports.routerV1.use('/pessoal', guys_routes_1.routerGuys);
exports.routerV1.use('/itemPcg', itemPcg_routes_1.routerItemPgc);
exports.routerV1.use('/page', page_routes_1.routerPage);
exports.routerV1.use('/notification', notification_routes_1.routerNotification);
exports.routerV1.use('/planilhaDeCompra', purchaseWorksheet_routes_1.default);
exports.routerV1.use('/pagar', pay_routes_1.routerPay);
exports.routerV1.use('/filial', branch_routes_1.routerBranch);
exports.routerV1.use('/local', local_routes_1.routerLocal);
exports.routerV1.use('/fornecedor', supplier_routes_1.routerSupplier);
