"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.routerPay = void 0;
const express_1 = __importDefault(require("express"));
const isAuthenticatedAcess_1 = __importDefault(require("../../middlewares/isAuthenticatedAcess"));
const payControllers_1 = require("../../controllers/payControllers");
exports.routerPay = express_1.default.Router();
const payControllers = new payControllers_1.PayControllers();
exports.routerPay.get('/', isAuthenticatedAcess_1.default, payControllers.list);
exports.routerPay.post('/', isAuthenticatedAcess_1.default, payControllers.approval);
exports.routerPay.get('/numeroDoc/:trpgNumDoc', isAuthenticatedAcess_1.default, payControllers.listNumDoc);
exports.routerPay.get('/periodo/:dtIni/:dtEnd', isAuthenticatedAcess_1.default, payControllers.listPeriod);
exports.routerPay.get('/cr/:cereCod', isAuthenticatedAcess_1.default, payControllers.listCere);
exports.routerPay.get('/numero/:trpgCod', isAuthenticatedAcess_1.default, payControllers.listNum);
exports.routerPay.get('/fornecedor/:fornCod', isAuthenticatedAcess_1.default, payControllers.listForn);
