"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const purchaseOrder_1 = require("../../queries/purchaseOrder");
const request_1 = require("../../queries/request");
const serviceContract_1 = require("../../queries/serviceContract");
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const sendNotification_1 = require("../../utils/sendNotification");
class SendNotificationPush {
    execute(cod, tipo, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (tipo === 'pedido') {
                    const queryPegaTokenUserQuery = (0, request_1.queryPegaTokenUserSql)(cod, database);
                    const queryPegaTokenUserData = yield usuarioRepositories_1.UsuarioRepository.query(queryPegaTokenUserQuery);
                    if (queryPegaTokenUserData[0]) {
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_1) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_1, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_2) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_2, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_3) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_3, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_4) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_4, cod, tipo);
                        }
                        return ({
                            message: 'Enviada com sucesso',
                            status: 200
                        });
                    }
                }
                if (tipo === 'solictação') {
                    const queryPegaTokenUserQuery = (0, purchaseOrder_1.queryPegaTokenUserSoco)(cod, database);
                    const queryPegaTokenUserData = yield usuarioRepositories_1.UsuarioRepository.query(queryPegaTokenUserQuery);
                    if (queryPegaTokenUserData[0]) {
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_1) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_1, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_2) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_2, cod, tipo);
                        }
                        return ({
                            message: 'Enviada com sucesso',
                            status: 200
                        });
                    }
                }
                if (tipo === 'contrato serviço') {
                    const queryPegaTokenUserQuery = (0, serviceContract_1.queryPegaTokenUserCocs)(cod, database);
                    const queryPegaTokenUserData = yield usuarioRepositories_1.UsuarioRepository.query(queryPegaTokenUserQuery);
                    if (queryPegaTokenUserData[0]) {
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_1) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_1, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_2) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_2, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_3) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_3, cod, tipo);
                        }
                        if (queryPegaTokenUserData[0].EXPO_TOKEN_4) {
                            (0, sendNotification_1.sendNotification)(queryPegaTokenUserData[0].EXPO_TOKEN_4, cod, tipo);
                        }
                        return ({
                            message: 'Enviada com sucesso',
                            status: 200
                        });
                    }
                }
                return ({
                    message: 'Error',
                    status: 400
                });
            }
            catch (error) {
                return ({
                    message: `Error ${error}`,
                    status: 400
                });
            }
        });
    }
}
exports.default = SendNotificationPush;
