"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListParametros = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const parametrosGerais_1 = require("../../queries/parametrosGerais");
class ListParametros {
    execute(database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const sql = (0, parametrosGerais_1.selectPagePag2StartAddPage)(database);
                const data = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
                return ({
                    message: data,
                    status: 200,
                    error: false
                });
            }
            catch (e) {
                return ({
                    message: e + '',
                    status: 500,
                    error: true
                });
            }
        });
    }
}
exports.ListParametros = ListParametros;
