"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListPayService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const pay_1 = require("../../queries/pay");
class ListPayService {
    execute(cod, queryString, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const autorizacaoCount = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT
          PAGE_NUM_AUTORIZACOES
        FROM
          PARAMETROS_GERAIS
      `);
                const selectSql = (0, pay_1.selectTrpg)(cod, autorizacaoCount[0].PAGE_NUM_AUTORIZACOES, queryString, database);
                console.log('====================================');
                console.log(selectSql);
                console.log('====================================');
                const querySelect = yield usuarioRepositories_1.UsuarioRepository.query(selectSql);
                return {
                    error: false,
                    message: querySelect,
                    status: 200
                };
            }
            catch (e) {
                return {
                    error: true,
                    message: `Internal Server Error: ${e}`,
                    status: 500
                };
            }
        });
    }
}
exports.ListPayService = ListPayService;
