"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApprovalPurchaseOrderService = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const purchaseOrder_1 = require("../../queries/purchaseOrder");
const verifyUser_1 = require("../../utils/verifyUser");
class ApprovalPurchaseOrderService {
    execute(sigla, password, posUsuaCod, socoCod, valorTotalSoco, database) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('====================================');
            console.log(database);
            console.log('====================================');
            try {
                const { 
                // eslint-disable-next-line camelcase
                usua_valor_aprov_solic, error, message, status } = yield (0, verifyUser_1.verifyUserApproval)(sigla, password, database);
                if (error) {
                    return ({
                        message,
                        error,
                        status
                    });
                }
                if (Number(usua_valor_aprov_solic) < valorTotalSoco) {
                    return ({
                        message: 'Úsuario não pode aprovar um valor tão alto',
                        error: true,
                        status: 403
                    });
                }
                const sqlContNumAprovaS = (0, purchaseOrder_1.countNumAprovaSoliCompra)(socoCod, database);
                console.log('====================================');
                console.log(sqlContNumAprovaS);
                console.log('====================================');
                const countNumAprovaS = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlContNumAprovaS);
                const sqlAprovaNumPage = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(`
        USE [${database}]
        SELECT 
          page_num_aprovacoes_solic,
          page_todas_aprovacoes_solic
        FROM 
          PARAMETROS_GERAIS
      `);
                let statusSQL = '';
                if (sqlAprovaNumPage[0].page_todas_aprovacoes_solic === 'S') {
                    if (sqlAprovaNumPage[0].page_num_aprovacoes_solic === 1) {
                        statusSQL = "SOCO_STATUS = 'AP',";
                    }
                    else if (sqlAprovaNumPage[0].page_num_aprovacoes_solic === 2 && countNumAprovaS[0].NUM === 1) {
                        statusSQL = "SOCO_STATUS = 'AP',";
                    }
                }
                else {
                    statusSQL = "SOCO_STATUS = 'AP',";
                }
                const sql = (0, purchaseOrder_1.updateASSSolicitacao)(socoCod, posUsuaCod, statusSQL, database);
                console.log('====================================');
                console.log(database);
                console.log('====================================');
                yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
                return ({
                    message: `Solicitação ${socoCod} aprovada com sucesso`,
                    error: false,
                    status: 200
                });
            }
            catch (e) {
                return ({
                    message: 'Internal Server Error' + e,
                    error: true,
                    status: 500
                });
            }
        });
    }
}
exports.ApprovalPurchaseOrderService = ApprovalPurchaseOrderService;
