"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListPedidoService = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const request_1 = require("../../queries/request");
const userResultCenter_1 = require("../../queries/userResultCenter");
const parametrosGerais_1 = require("../../queries/parametrosGerais");
class ListPedidoService {
    execute(cod, queryString, database) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const array = [];
                const selectPag2ContrUsuaSmpCrPedComQuery = (0, parametrosGerais_1.selectPag2ContrUsuaSmpCrPedCom)(database);
                const selectPag2ContrUsuaSmpCrPedComData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(selectPag2ContrUsuaSmpCrPedComQuery);
                if (selectPag2ContrUsuaSmpCrPedComData[0].PAG2_CONTR_USUA_SMP_CR_PED_COM === 'S') {
                    const selectUsuaCrQuery = (0, userResultCenter_1.selectUsuaCr)(cod, database);
                    const selectUsuaCrDatas = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(selectUsuaCrQuery);
                    const arrayCere = [];
                    let queryStringPese = `
        AND
          PESE_CERE_COD IN(0)
        `;
                    let queryStringPeit = `
        AND
          PEIT_CERE_COD IN(0)
        `;
                    if (selectUsuaCrDatas.length > 0) {
                        try {
                            for (var _d = true, selectUsuaCrDatas_1 = __asyncValues(selectUsuaCrDatas), selectUsuaCrDatas_1_1; selectUsuaCrDatas_1_1 = yield selectUsuaCrDatas_1.next(), _a = selectUsuaCrDatas_1_1.done, !_a;) {
                                _c = selectUsuaCrDatas_1_1.value;
                                _d = false;
                                try {
                                    const selectUsuaCrData = _c;
                                    arrayCere.push(selectUsuaCrData.USCR_CERE_COD);
                                    queryStringPese = `
          AND
            PESE_CERE_COD IN(${arrayCere})
          `;
                                    queryStringPeit = `
          AND
            PEIT_CERE_COD IN(${arrayCere})
          `;
                                }
                                finally {
                                    _d = true;
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (!_d && !_a && (_b = selectUsuaCrDatas_1.return)) yield _b.call(selectUsuaCrDatas_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                    }
                    const sql1 = (0, request_1.selectPedidoEstoqueCere1)(cod, queryString, queryStringPese, queryStringPeit, database);
                    const sql2 = (0, request_1.selectPedidoEstoqueCere2)(cod, queryString, queryStringPese, queryStringPeit, database);
                    const sql3 = (0, request_1.selectPedidoEstoqueCere3)(cod, queryString, queryStringPese, queryStringPeit, database);
                    const sql4 = (0, request_1.selectPedidoEstoqueCere4)(cod, queryString, queryStringPese, queryStringPeit, database);
                    const listPedido1 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql1);
                    const listPedido2 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql2);
                    const listPedido3 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql3);
                    const listPedido4 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql4);
                    if (listPedido1.length > 0) {
                        listPedido1.map((pos) => array.push(pos));
                    }
                    if (listPedido2.length > 0) {
                        listPedido2.map((pos) => array.push(pos));
                    }
                    if (listPedido3.length > 0) {
                        listPedido3.map((pos) => array.push(pos));
                    }
                    if (listPedido4.length > 0) {
                        listPedido4.map((pos) => array.push(pos));
                    }
                }
                else {
                    const sql1 = (0, request_1.selectPedidoEstoque1)(cod, queryString, database);
                    const sql2 = (0, request_1.selectPedidoEstoque2)(cod, queryString, database);
                    const sql3 = (0, request_1.selectPedidoEstoque3)(cod, queryString, database);
                    const sql4 = (0, request_1.selectPedidoEstoque4)(cod, queryString, database);
                    const listPedido1 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql1);
                    const listPedido2 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql2);
                    const listPedido3 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql3);
                    const listPedido4 = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql4);
                    if (listPedido1.length > 0) {
                        listPedido1.map((pos) => array.push(pos));
                    }
                    if (listPedido2.length > 0) {
                        listPedido2.map((pos) => array.push(pos));
                    }
                    if (listPedido3.length > 0) {
                        listPedido3.map((pos) => array.push(pos));
                    }
                    if (listPedido4.length > 0) {
                        listPedido4.map((pos) => array.push(pos));
                    }
                }
                return {
                    status: 200,
                    message: array
                };
            }
            catch (e) {
                return {
                    status: 500,
                    message: 'Internal server error'
                };
            }
        });
    }
}
exports.ListPedidoService = ListPedidoService;
