"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApprovalRequestService = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const request_1 = require("../../queries/request");
const verifyUser_1 = require("../../utils/verifyUser");
class ApprovalRequestService {
    execute(sigla, USUA_SENHA_APP, posUsuaCod, pediCod, pediNumero, database) {
        return __awaiter(this, void 0, void 0, function* () {
            const { error, message, status } = yield (0, verifyUser_1.verifyUserApproval)(sigla, USUA_SENHA_APP, database);
            console.log('====================================');
            console.log(error, message, status);
            console.log('====================================');
            if (error) {
                return ({
                    message,
                    error,
                    status
                });
            }
            let sqlQuery = '';
            const sqlCountNumAprovaPedido = (0, request_1.countNumAprovaPedido)(pediCod, database);
            const valCountNumAprovaPedido = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlCountNumAprovaPedido);
            const valCountNumAprovaPedidoBD = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(`
      USE [${database}]
      SELECT 
        PAGE_NUM_APROVACOES_PEDIDO,
        PAGE_TODAS_APROVACOES_PEDIDO
      FROM 
        PARAMETROS_GERAIS
      `);
            if (valCountNumAprovaPedidoBD[0].PAGE_TODAS_APROVACOES_PEDIDO === 'S') {
                if (valCountNumAprovaPedidoBD[0].PAGE_NUM_APROVACOES_PEDIDO === 1) {
                    sqlQuery = "PEDI_STATUS = 'A',";
                }
                else if (valCountNumAprovaPedidoBD[0].PAGE_NUM_APROVACOES_PEDIDO === 2 && valCountNumAprovaPedido[0].NUM === 1) {
                    sqlQuery = "PEDI_STATUS = 'A',";
                }
                else if (valCountNumAprovaPedidoBD[0].PAGE_NUM_APROVACOES_PEDIDO === 3 && valCountNumAprovaPedido[0].NUM === 2) {
                    sqlQuery = "PEDI_STATUS = 'A',";
                }
                else if (valCountNumAprovaPedidoBD[0].PAGE_NUM_APROVACOES_PEDIDO === 4 && valCountNumAprovaPedido[0].NUM === 3) {
                    sqlQuery = "PEDI_STATUS = 'A',";
                }
            }
            else {
                sqlQuery = "PEDI_STATUS = 'A',";
            }
            const sql = (0, request_1.updatePedidoASS)(pediCod, posUsuaCod, sqlQuery, database);
            yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
            return ({
                message: `Pedido ${pediNumero} aprovado com sucesso`,
                error: false,
                status: 200
            });
        });
    }
}
exports.ApprovalRequestService = ApprovalRequestService;
