"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetDetailsRequestServices = void 0;
const request_1 = require("../../queries/request");
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
class GetDetailsRequestServices {
    execute(PEDI_COD, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const sql = (0, request_1.selectPedidosItemServico)(PEDI_COD, database);
                const requestItens = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
                return {
                    status: 200,
                    message: requestItens
                };
            }
            catch (e) {
                return {
                    status: 500,
                    message: 'Internal server error'
                };
            }
        });
    }
}
exports.GetDetailsRequestServices = GetDetailsRequestServices;
