"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validCereFornPedi = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const request_1 = require("../../queries/request");
const userResultCenter_1 = require("../../queries/userResultCenter");
const pegaPeriodoPedido_1 = require("../../utils/pegaPeriodoPedido");
const parametrosGerais_1 = require("../../queries/parametrosGerais");
const verifyUser_1 = require("../../utils/verifyUser");
const validCereFornPedi = (cod, cereCod, valTotal, fornCod, pediCod, database) => __awaiter(void 0, void 0, void 0, function* () {
    const { USUA_VALOR_APROVACAO, USUA_VALOR_APROVACAO_MENSAL } = yield (0, verifyUser_1.verifyUsercodWithoutPassword)(cod, database);
    const periodo = (0, pegaPeriodoPedido_1.pegaPeriodo)('PEDI_DATA');
    const sqlUsuarioCr = (0, userResultCenter_1.selectUsuaCrParametros)(cod + '', cereCod, database);
    const selectPag2ContrUsuaSmpCrPedComQuery = (0, parametrosGerais_1.selectPag2ContrUsuaSmpCrPedCom)(database);
    const selectPag2ContrUsuaSmpCrPedComData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(selectPag2ContrUsuaSmpCrPedComQuery);
    const sqlUsuarioCrData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlUsuarioCr);
    if (selectPag2ContrUsuaSmpCrPedComData[0].PAG2_CONTR_USUA_SMP_CR_PED_COM === 'S') {
        if (!sqlUsuarioCrData[0]) {
            return ({
                message: 'Parametros de usuario CR não estão configurados corretamente',
                error: true,
                status: 400
            });
        }
        else if (sqlUsuarioCrData[0].USCR_VLR_MAX_APROV_PED) {
            const USCR_VLR_MAX_APROV_PED = sqlUsuarioCrData[0].USCR_VLR_MAX_APROV_PED;
            if (USCR_VLR_MAX_APROV_PED < parseInt(valTotal)) {
                return ({
                    message: `Pedido ${pediCod} não poderá ser aprovado poís valor do pedido acima do valor que o usuario pode aprovar nesse CR`,
                    error: true,
                    status: 400
                });
            }
        }
        else if (sqlUsuarioCrData[0].USCR_VLR_MAX_APROV_PED_FORN) {
            const USCR_VLR_MAX_APROV_PED_FORN = sqlUsuarioCrData[0].USCR_VLR_MAX_APROV_PED_FORN;
            const sqlTotalFornCerePedido = (0, request_1.totalFornCerePedido)(cereCod, fornCod, periodo, database);
            if (USCR_VLR_MAX_APROV_PED_FORN > 0) {
                const totalFornCerePedidoData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlTotalFornCerePedido);
                let totalFornCerePedidoValue = 0;
                for (let i = 0; i < totalFornCerePedidoData; i++) {
                    totalFornCerePedidoValue += totalFornCerePedidoData[i].VALOR;
                }
                totalFornCerePedidoValue += parseInt(valTotal);
                if (USCR_VLR_MAX_APROV_PED_FORN < totalFornCerePedidoValue) {
                    return ({
                        message: `Pedido ${pediCod} não poderá ser aprovado poís valor do pedido acima do valor mensal de aprovação para esse fornecedor`,
                        error: true,
                        status: 400
                    });
                }
            }
        }
    }
    else {
        if (USUA_VALOR_APROVACAO && USUA_VALOR_APROVACAO_MENSAL) {
            if (parseInt(valTotal) > Number(USUA_VALOR_APROVACAO)) {
                return ({
                    message: `Pedido ${pediCod} não poderá ser aprovado poís valor do pedido acima do valor que o usuario pode aprovar`,
                    error: true,
                    status: 400
                });
            }
            const sqlTotalUsuaPedido = (0, request_1.totalUsuaPedido)(cod + '', periodo, database);
            const totalUsuaPedidoData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlTotalUsuaPedido);
            let totalUsuaPedidoValue = 0;
            for (let i = 0; i < totalUsuaPedidoData; i++) {
                totalUsuaPedidoValue += totalUsuaPedidoData[i].VALOR;
            }
            totalUsuaPedidoValue += parseInt(valTotal);
            if (Number(USUA_VALOR_APROVACAO_MENSAL) < totalUsuaPedidoValue) {
                return ({
                    message: `Pedido ${pediCod} não poderá ser aprovado poís valor do pedido acima do valor que o usuario pode aprovar por mês`,
                    error: true,
                    status: 400
                });
            }
        }
        else if (USUA_VALOR_APROVACAO || !USUA_VALOR_APROVACAO_MENSAL) {
            if (parseInt(valTotal) > Number(USUA_VALOR_APROVACAO)) {
                return ({
                    message: `Pedido ${pediCod} não poderá ser aprovado poís valor do pedido acima do valor que o usuario pode aprovar`,
                    error: true,
                    status: 400
                });
            }
        }
        else if (!USUA_VALOR_APROVACAO || USUA_VALOR_APROVACAO_MENSAL) {
            const sqlTotalUsuaPedido = (0, request_1.totalUsuaPedido)(cod + '', periodo, database);
            const totalUsuaPedidoData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlTotalUsuaPedido);
            let totalUsuaPedidoValue = 0;
            for (let i = 0; i < totalUsuaPedidoData; i++) {
                totalUsuaPedidoValue += totalUsuaPedidoData[i].VALOR;
            }
            totalUsuaPedidoValue += parseInt(valTotal);
            if (Number(USUA_VALOR_APROVACAO_MENSAL) < totalUsuaPedidoValue) {
                return ({
                    message: `Pedido ${pediCod} não poderá ser aprovado poís valor do pedido acima do valor que o usuario pode aprovar por mês`,
                    error: true,
                    status: 400
                });
            }
        }
    }
    return ({
        message: '',
        error: false,
        status: 200
    });
});
exports.validCereFornPedi = validCereFornPedi;
