"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListResultCenterService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const relUserResultCenter_1 = require("../../queries/relUserResultCenter");
const resultCenter_1 = require("../../queries/resultCenter");
const verifyUser_1 = require("../../utils/verifyUser");
class ListResultCenterService {
    execute(cod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { error, message, status, USUA_TIPO } = yield (0, verifyUser_1.verifyUsercodWithoutPassword)(cod, database);
                if (error) {
                    return {
                        error,
                        message,
                        status
                    };
                }
                if (USUA_TIPO === 'E') {
                    const sqlSpecial = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT 
          CERE_NOME,
          CERE_SIGLA,
          CERE_PLCG_COD,
          CERE_COD
        FROM
          CENTRO_RESULTADO
      `);
                    return {
                        error: false,
                        message: sqlSpecial,
                        status: 200
                    };
                }
                const selectCRUsuaQuery = (0, relUserResultCenter_1.selectCRUsua)(cod, database);
                const verifyCR = yield usuarioRepositories_1.UsuarioRepository.query(selectCRUsuaQuery);
                let cods = '0';
                verifyCR.forEach((element) => {
                    if (cods === '0') {
                        cods = element.USCR_CERE_COD;
                    }
                    else {
                        cods = cods + ',' + element.USCR_CERE_COD;
                    }
                });
                const selectCereQuery = (0, resultCenter_1.selectCere)(cods, '', database);
                console.log('====================================');
                console.log(selectCereQuery);
                console.log('====================================');
                const resultQueryCereSelect = yield usuarioRepositories_1.UsuarioRepository.query(selectCereQuery);
                return {
                    error: false,
                    message: resultQueryCereSelect,
                    status: 200
                };
            }
            catch (e) {
                return {
                    error: true,
                    message: 'Internal server error' + e,
                    status: 500
                };
            }
        });
    }
}
exports.ListResultCenterService = ListResultCenterService;
