"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListDetailsServiceContract = void 0;
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const serviceContract_1 = require("../../queries/serviceContract");
class ListDetailsServiceContract {
    execute(cod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const selectDetailsServiceContractSql = (0, serviceContract_1.selectDetailsServiceContract)(cod, database);
                const selectDetailsServiceContractData = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(selectDetailsServiceContractSql);
                return {
                    message: selectDetailsServiceContractData,
                    status: 200
                };
            }
            catch (error) {
                return {
                    message: 'Internal server error',
                    status: 500
                };
            }
        });
    }
}
exports.ListDetailsServiceContract = ListDetailsServiceContract;
