"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApprovalBulletinService = void 0;
const dotenv_1 = __importDefault(require("dotenv"));
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
const serviceContractBulletin_1 = require("../../queries/serviceContractBulletin");
const verifyUser_1 = require("../../utils/verifyUser");
dotenv_1.default.config();
class ApprovalBulletinService {
    execute(cod, codBulletin, ass, password, cereCod, valueBulletin, fornCod, database, sigla) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { error, message, status } = yield (0, verifyUser_1.verifyUserApproval)(sigla, password, database);
                if (error) {
                    return ({
                        message,
                        erro: error,
                        status
                    });
                }
                const pag2Aprovs = yield usuarioRepositories_1.UsuarioRepository.query(`
      USE [${database}]
      SELECT
        PAG2_APROV_USUA_CR_VALOR,
        PAG2_APROV_USUA_CR_VALOR_FORN
      FROM
        PARAMETROS_GERAIS_2
      `);
                if (pag2Aprovs[0].PAG2_APROV_USUA_CR_VALOR === 'S') {
                    const pegaValorAprovQuery = (0, serviceContractBulletin_1.pegaValorAprovCrSql)(cereCod, cod, database);
                    const pegaValorAprov = yield usuarioRepositories_1.UsuarioRepository.query(pegaValorAprovQuery);
                    let valorTotal = 0;
                    if (pegaValorAprov[0]) {
                        valorTotal = pegaValorAprov[0].valorTotal;
                    }
                    const valorTotalMes = valorTotal + parseFloat(valueBulletin);
                    const pegarValorUscrMax = yield usuarioRepositories_1.UsuarioRepository.query(`
      USE [${database}]
        SELECT
          USCR_VLR_MAX_APROV_PED
        FROM 
          USUARIO_CR
        WHERE 
          USCR_CERE_COD = ${cereCod}
        AND
          USCR_USUA_COD = ${cod}
      `);
                    if (!pegarValorUscrMax[0]) {
                        return ({
                            message: 'Úsuario sem valor configurado para esse CR',
                            erro: true,
                            status: 400
                        });
                    }
                    if (!pegarValorUscrMax[0].USCR_VLR_MAX_APROV_PED) {
                        return ({
                            message: 'Usuário não tem acesso ao cr ou valor de aprovação não foi informado.',
                            erro: true,
                            status: 400
                        });
                    }
                    if (valorTotalMes > pegarValorUscrMax[0].USCR_VLR_MAX_APROV_PED) {
                        return ({
                            message: 'Usuário não pode aprovar um valor tão alto para esse cr.',
                            erro: true,
                            status: 400
                        });
                    }
                }
                else if (pag2Aprovs[0].PAG2_APROV_USUA_CR_VALOR_FORN === 'S') {
                    const pegaValorAprovQuery = (0, serviceContractBulletin_1.pegaValorAprovCrFornSql)(cereCod, fornCod, cod, database);
                    const pegaValorAprov = yield usuarioRepositories_1.UsuarioRepository.query(pegaValorAprovQuery);
                    const valorTotalMes = pegaValorAprov[0].valorTotal + parseFloat(valueBulletin);
                    let nValorAprovUsuaMensal = 0;
                    const pegarValorUscrMax = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT
          USCR_VLR_MAX_APROV_PED_FORN
        FROM 
          USUARIO_CR
        WHERE 
          USCR_CERE_COD = ${cereCod}
        AND
          USCR_USUA_COD = ${cod}
      `);
                    const pegarValorFucvMax = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT
          FUCV_VALOR_MAXIMO
        FROM 
          FORN_USUA_CR_VALOR
        WHERE 
          FUCV_CERE_COD = ${cereCod}
        AND
          FUCV_USUA_COD = ${cod}
        AND
          FUCV_FORN_COD = ${fornCod}
      `);
                    if (!pegarValorFucvMax[0].FUCV_VALOR_MAXIMO) {
                        if (!pegarValorUscrMax[0].USCR_VLR_MAX_APROV_PED_FORN) {
                            return ({
                                message: 'Usuário não tem acesso ao cr ou valor de aprovação não foi informado.',
                                erro: true,
                                status: 400
                            });
                        }
                        nValorAprovUsuaMensal = pegarValorUscrMax[0].USCR_VLR_MAX_APROV_PED_FORN;
                    }
                    else {
                        nValorAprovUsuaMensal = pegarValorFucvMax[0].FUCV_VALOR_MAXIMO;
                    }
                    if (valorTotalMes > nValorAprovUsuaMensal) {
                        return ({
                            message: 'Usuário não pode aprovar um valor tão alto para esse cr.',
                            erro: true,
                            status: 400
                        });
                    }
                }
                let statusSQL = '';
                const sql = (0, serviceContractBulletin_1.countNumAprovaBoletim)(codBulletin, database);
                const countNumAprovaBole = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sql);
                const selectPageNumAprova = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(`
      USE [${database}]
       SELECT 
        PAG2_NUM_APROVACOES_BOLETIM,
        PAG2_TODAS_APROVACOES_BOLETIM
      FROM 
        PARAMETROS_GERAIS_2
    `);
                if (selectPageNumAprova[0].PAG2_TODAS_APROVACOES_BOLETIM === 'S') {
                    if (selectPageNumAprova[0].PAG2_NUM_APROVACOES_BOLETIM === 1) {
                        statusSQL = "BOCS_STATUS = 'AP',";
                    }
                    else if (selectPageNumAprova[0].PAG2_NUM_APROVACOES_BOLETIM === 2 && countNumAprovaBole[0].NUM === 1) {
                        statusSQL = "BOCS_STATUS = 'AP',";
                    }
                }
                else {
                    statusSQL = "BOCS_STATUS = 'AP',";
                }
                const sqlUpdate = (0, serviceContractBulletin_1.updateBoletim)(ass, statusSQL, codBulletin, database);
                yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlUpdate);
                return {
                    status: 200,
                    message: 'Boletim contrato serviço aprovado ',
                    erro: false
                };
            }
            catch (e) {
                return ({
                    message: 'Internal server error',
                    erro: true,
                    status: 500
                });
            }
        });
    }
}
exports.ApprovalBulletinService = ApprovalBulletinService;
