"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListSupplierService = void 0;
const filialRepositories_1 = require("../../typeorm/repository/filialRepositories");
class ListSupplierService {
    execute(database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const sql = `
      USE [${database}]
      SELECT
        FORN_NOME,
        FORN_COD
      FROM
        FORNECEDOR
    `;
                const supplierList = yield filialRepositories_1.FilialRepository.query(sql);
                return {
                    error: false,
                    message: supplierList,
                    status: 200
                };
            }
            catch (e) {
                return ({
                    error: true,
                    message: 'Internal Server Error',
                    status: 500
                });
            }
        });
    }
}
exports.ListSupplierService = ListSupplierService;
