"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListUnidMatService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const unidMat_1 = require("../../queries/unidMat");
class ListUnidMatService {
    execute(database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const selectAllUnidMatSql = (0, unidMat_1.selectAllUnidMat)(database);
                const selectAllUnidMatData = yield usuarioRepositories_1.UsuarioRepository.query(selectAllUnidMatSql);
                return {
                    error: false,
                    message: selectAllUnidMatData,
                    status: 200
                };
            }
            catch (e) {
                return {
                    error: true,
                    message: 'Internal server error',
                    status: 500
                };
            }
        });
    }
}
exports.ListUnidMatService = ListUnidMatService;
