"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VerfifyVersion = void 0;
const dotenv_1 = __importDefault(require("dotenv"));
dotenv_1.default.config();
class VerfifyVersion {
    execute(version, platform) {
        return __awaiter(this, void 0, void 0, function* () {
            const versionAndroid = parseInt(process.env.VERSION_ANDROID + '');
            const versionIos = parseInt(process.env.VERSION_IOS + '');
            let message = 'atualizado';
            let link = '';
            if (platform === 'android' && version < versionAndroid) {
                message = 'desatualizado';
                link = 'https://play.google.com/store/apps/details?id=com.inova_sgn.sgn_mobile';
            }
            if (platform === 'ios' && version < versionIos) {
                message = 'desatualizado';
                link = 'https://play.google.com/store/apps/details?id=com.inova_sgn.sgn_mobile';
            }
            return {
                message,
                link
            };
        });
    }
}
exports.VerfifyVersion = VerfifyVersion;
