"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListWarehouseService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const parametrosGerais_1 = require("../../queries/parametrosGerais");
const werehouse_1 = require("../../queries/werehouse");
const verifyUser_1 = require("../../utils/verifyUser");
class ListWarehouseService {
    execute(cod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { message, error, status, USUA_TIPO } = yield (0, verifyUser_1.verifyUsercodWithoutPassword)(cod, database);
                if (error) {
                    return ({
                        message,
                        error,
                        status
                    });
                }
                const sqlQueryPage = (0, parametrosGerais_1.sqlPageControleUsuarioCrAlmox)(database);
                const sqlParametro = yield usuarioRepositories_1.UsuarioRepository.query(sqlQueryPage);
                if (sqlParametro[0].PAG2_CONTROLE_USUARIO_CR_ALMOX === 'S') {
                    if (USUA_TIPO === 'E') {
                        const almoSql = (0, werehouse_1.selectAllAlmo)(database);
                        const dataQueryAlmo = yield usuarioRepositories_1.UsuarioRepository.query(almoSql);
                        return {
                            error: false,
                            message: dataQueryAlmo,
                            status: 200
                        };
                    }
                    const almoSql = (0, werehouse_1.selectAlmoRelCere)(cod, database);
                    const dataQueryAlmo = yield usuarioRepositories_1.UsuarioRepository.query(almoSql);
                    return {
                        error: false,
                        message: dataQueryAlmo,
                        status: 200
                    };
                }
                else if (sqlParametro[0].PAG2_REL_USUA_ALMOX === 'S') {
                    if (USUA_TIPO === 'E') {
                        const almoSql = (0, werehouse_1.selectAllAlmo)(database);
                        const dataQueryAlmo = yield usuarioRepositories_1.UsuarioRepository.query(almoSql);
                        return {
                            error: false,
                            message: dataQueryAlmo,
                            status: 200
                        };
                    }
                    const almoSql = (0, werehouse_1.SelectalmoRelUsuario)(cod, database);
                    const dataQueryAlmo = yield usuarioRepositories_1.UsuarioRepository.query(almoSql);
                    return {
                        error: false,
                        message: dataQueryAlmo,
                        status: 200
                    };
                }
                const almoSql = (0, werehouse_1.selectAllAlmo)(database);
                const dataQueryAlmo = yield usuarioRepositories_1.UsuarioRepository.query(almoSql);
                return {
                    error: false,
                    message: dataQueryAlmo,
                    status: 200
                };
            }
            catch (e) {
                return ({
                    message: 'Internal server error',
                    error: true,
                    status: 500
                });
            }
        });
    }
}
exports.ListWarehouseService = ListWarehouseService;
