"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendNotification = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
const expo_server_sdk_1 = require("expo-server-sdk");
const sendNotification = (tokenExpo, cod, tipo) => {
    const expo = new expo_server_sdk_1.Expo();
    const messages = [];
    const somePushTokens = [];
    somePushTokens.push(tokenExpo);
    for (const pushToken of somePushTokens) {
        if (!expo_server_sdk_1.Expo.isExpoPushToken(pushToken)) {
            console.error(`Push token ${pushToken} is not a valid Expo push token`);
            continue;
        }
        messages.push({
            to: pushToken,
            sound: 'default',
            body: `Nova ${tipo} para poder ser aprovado ${cod}`
        });
    }
    const chunks = expo.chunkPushNotifications(messages);
    const tickets = [];
    (() => __awaiter(void 0, void 0, void 0, function* () {
        for (const chunk of chunks) {
            try {
                const ticketChunk = yield expo.sendPushNotificationsAsync(chunk);
                console.log(ticketChunk);
                tickets.push(...ticketChunk);
            }
            catch (error) {
                console.error(error);
            }
        }
    }))();
};
exports.sendNotification = sendNotification;
