"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const check_password_strength_1 = require("check-password-strength");
const validPassword = (password) => {
    if (password.length < 10) {
        return {
            message: 'Senha deve conter mais de 10 caracteres',
            error: true,
            status: 400
        };
    }
    if ((0, check_password_strength_1.passwordStrength)(password).value === 'Strong') {
        return {
            message: '',
            error: false,
            status: 200
        };
    }
    else {
        return {
            message: 'Senha deve ser forte',
            error: true,
            status: 400
        };
    }
};
exports.default = validPassword;
