"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.verifyUsercodWithOutSignUp = exports.verifyUsercodWithoutPassword = exports.verifyUsercod = exports.verifyUserSignUp = exports.verifyUserApproval = exports.verifyUserLogin = void 0;
const user_1 = require("../queries/user");
const usuarioRepositories_1 = require("../typeorm/repository/usuarioRepositories");
const bcrypt_1 = __importDefault(require("bcrypt"));
const validPassword_1 = __importDefault(require("./validPassword"));
const verifyUserLogin = (acronym, password, database) => __awaiter(void 0, void 0, void 0, function* () {
    const sqlVerifyUser = (0, user_1.verifyUserQuery)(acronym, database);
    const existsUser = yield usuarioRepositories_1.UsuarioRepository.query(sqlVerifyUser);
    if (!existsUser[0]) {
        return ({
            message: 'Login ou senha incorreto',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    if (!existsUser[0].USUA_SENHA_APP || existsUser[0].USUA_SENHA_APP === '') {
        return ({
            message: 'Úsuario sem senha cadastrada',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    const passwordBD = existsUser[0].USUA_SENHA_APP;
    const comparePassword = yield bcrypt_1.default.compare(password, passwordBD);
    if (!comparePassword) {
        return ({
            message: 'Login ou senha incorreto',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    if (existsUser[0].USUA_BLOQ !== 'N') {
        return ({
            message: 'Úsuario bloqueado',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    return ({
        message: '',
        error: false,
        userCod: existsUser[0].USUA_COD,
        status: 0,
        usua_valor_aprov_solic: '',
        USUA_VALOR_APROVACAO: existsUser[0].USUA_VALOR_APROVACAO,
        USUA_VALOR_APROVACAO_MENSAL: existsUser[0].USUA_VALOR_APROVACAO_MENSAL
    });
});
exports.verifyUserLogin = verifyUserLogin;
const verifyUserApproval = (acronym, password, database) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const sqlVerifyUser = (0, user_1.verifyUserQuery)(acronym, database);
        const existsUser = yield usuarioRepositories_1.UsuarioRepository.query(sqlVerifyUser);
        if (!existsUser[0]) {
            return ({
                message: 'Usuario inexistente',
                error: true,
                status: 400,
                userCod: '',
                usua_valor_aprov_solic: '',
                USUA_VALOR_APROVACAO: '',
                USUA_VALOR_APROVACAO_MENSAL: '',
                USUA_VALOR_APROVA_CONT_SERV: ''
            });
        }
        if (!existsUser[0].USUA_SENHA_APP || existsUser[0].USUA_SENHA_APP === '') {
            return ({
                message: 'Úsuario sem senha cadastrada',
                error: true,
                status: 400,
                userCod: '',
                usua_valor_aprov_solic: '',
                USUA_VALOR_APROVACAO: '',
                USUA_VALOR_APROVACAO_MENSAL: '',
                USUA_VALOR_APROVA_CONT_SERV: ''
            });
        }
        const passwordBD = existsUser[0].USUA_SENHA_APP;
        const comparePassword = yield bcrypt_1.default.compare(password, passwordBD);
        console.log('====================================');
        console.log(sqlVerifyUser);
        console.log('====================================');
        if (!comparePassword) {
            return ({
                message: 'Senha incorreta',
                error: true,
                status: 400,
                userCod: '',
                usua_valor_aprov_solic: '',
                USUA_VALOR_APROVACAO: '',
                USUA_VALOR_APROVACAO_MENSAL: '',
                USUA_VALOR_APROVA_CONT_SERV: ''
            });
        }
        if (existsUser[0].USUA_BLOQ !== 'N') {
            return ({
                message: 'Úsuario bloqueado',
                error: true,
                status: 400,
                userCod: '',
                usua_valor_aprov_solic: '',
                USUA_VALOR_APROVACAO: '',
                USUA_VALOR_APROVACAO_MENSAL: '',
                USUA_VALOR_APROVA_CONT_SERV: ''
            });
        }
        return ({
            message: '',
            error: false,
            userCod: existsUser[0].USUA_COD,
            status: 200,
            usua_valor_aprov_solic: existsUser[0].usua_valor_aprov_solic,
            USUA_VALOR_APROVACAO: existsUser[0].USUA_VALOR_APROVACAO,
            USUA_VALOR_APROVACAO_MENSAL: existsUser[0].USUA_VALOR_APROVACAO_MENSAL,
            USUA_VALOR_APROVA_CONT_SERV: existsUser[0].USUA_VALOR_APROVA_CONT_SERV
        });
    }
    catch (e) {
        return ({
            message: 'Internal server error: ' + e,
            error: true,
            status: 500,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: '',
            USUA_VALOR_APROVA_CONT_SERV: ''
        });
    }
});
exports.verifyUserApproval = verifyUserApproval;
const verifyUserSignUp = (acronym, password, database) => __awaiter(void 0, void 0, void 0, function* () {
    const sqlVerifyUser = (0, user_1.verifyUserQuery)(acronym, database);
    const existsUser = yield usuarioRepositories_1.UsuarioRepository.query(sqlVerifyUser);
    if (!existsUser[0]) {
        return ({
            message: 'Login ou senha incorreto',
            error: true,
            status: 400
        });
    }
    if (existsUser[0].USUA_BLOQ !== 'N') {
        return ({
            message: 'Úsuario bloqueado',
            error: true,
            status: 400
        });
    }
    const { message, error, status } = (0, validPassword_1.default)(password);
    if (error) {
        return ({
            message,
            error,
            status
        });
    }
    return ({
        message: '',
        error: false,
        status: 0
    });
});
exports.verifyUserSignUp = verifyUserSignUp;
const verifyUsercod = (cod, password, database) => __awaiter(void 0, void 0, void 0, function* () {
    const sqlVerifyUser = (0, user_1.verifyUserCodQuery)(cod, database);
    const existsUser = yield usuarioRepositories_1.UsuarioRepository.query(sqlVerifyUser);
    if (!existsUser[0]) {
        return ({
            message: 'Login ou senha incorreto',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    if (!existsUser[0].USUA_SENHA_APP || existsUser[0].USUA_SENHA_APP === '') {
        return ({
            message: 'Úsuario sem senha cadastrada',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    const passwordBD = existsUser[0].USUA_SENHA_APP;
    const comparePassword = yield bcrypt_1.default.compare(password, passwordBD);
    if (!comparePassword) {
        return ({
            message: 'Login ou senha incorreto',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    if (existsUser[0].USUA_BLOQ !== 'N') {
        return ({
            message: 'Úsuario bloqueado',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: ''
        });
    }
    return ({
        message: '',
        error: false,
        userCod: existsUser[0].USUA_COD,
        status: 0,
        usua_valor_aprov_solic: '',
        USUA_VALOR_APROVACAO: existsUser[0].USUA_VALOR_APROVACAO,
        USUA_VALOR_APROVACAO_MENSAL: existsUser[0].USUA_VALOR_APROVACAO_MENSAL
    });
});
exports.verifyUsercod = verifyUsercod;
const verifyUsercodWithoutPassword = (cod, database) => __awaiter(void 0, void 0, void 0, function* () {
    const sqlVerifyUser = (0, user_1.verifyUserCodQuery)(cod, database);
    const existsUser = yield usuarioRepositories_1.UsuarioRepository.query(sqlVerifyUser);
    if (!existsUser[0]) {
        return ({
            message: 'Login incorreto',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: '',
            USUA_TIPO: ''
        });
    }
    if (existsUser[0].USUA_BLOQ !== 'N') {
        return ({
            message: 'Úsuario bloqueado',
            error: true,
            status: 400,
            userCod: '',
            usua_valor_aprov_solic: '',
            USUA_VALOR_APROVACAO: '',
            USUA_VALOR_APROVACAO_MENSAL: '',
            USUA_TIPO: ''
        });
    }
    return ({
        message: '',
        error: false,
        userCod: existsUser[0].USUA_COD,
        status: 0,
        usua_valor_aprov_solic: '',
        USUA_VALOR_APROVACAO: existsUser[0].USUA_VALOR_APROVACAO,
        USUA_VALOR_APROVACAO_MENSAL: existsUser[0].USUA_VALOR_APROVACAO_MENSAL,
        USUA_TIPO: existsUser[0].USUA_TIPO
    });
});
exports.verifyUsercodWithoutPassword = verifyUsercodWithoutPassword;
const verifyUsercodWithOutSignUp = (cod, database) => __awaiter(void 0, void 0, void 0, function* () {
    const sqlVerifyUser = (0, user_1.verifyUserCodQuery)(cod, database);
    const existsUser = yield usuarioRepositories_1.UsuarioRepository.query(sqlVerifyUser);
    if (existsUser[0].USUA_BLOQ !== 'N') {
        return ({
            message: 'Úsuario bloqueado',
            error: true,
            status: 400,
            userTipo: existsUser[0].USUA_TIPO
        });
    }
    return ({
        message: '',
        error: false,
        userTipo: existsUser[0].USUA_TIPO,
        status: 0
    });
});
exports.verifyUsercodWithOutSignUp = verifyUsercodWithOutSignUp;
